/*
 * LinkedCell_ViewUnitTest.hpp
 *
 *  Created on: Nov 18, 2011
 *      Author: heber
 */

#ifndef LINKEDCELL_VIEWUNITTEST_HPP_
#define LINKEDCELL_VIEWUNITTEST_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

class Box;

namespace LinkedCell {
  class LinkedCell_View;
}

#include <cppunit/extensions/HelperMacros.h>

/********************************************** Test classes **************************************/

class LinkedCell_ViewTest : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE( LinkedCell_ViewTest) ;
    CPPUNIT_TEST ( getAllNeighborsTest );
    CPPUNIT_TEST ( getPointsInsideSphereTest );
    CPPUNIT_TEST ( RAIIMapTest );
    CPPUNIT_TEST_SUITE_END();

public:
      void setUp();
      void tearDown();

      void getAllNeighborsTest();
      void getPointsInsideSphereTest();
      void RAIIMapTest();

private:
      typedef std::set<TesselPoint *> PointSet;
      PointSet NodeList;

      Box *domain;
      LinkedCell::LinkedCell_Model *LCImpl;
      LinkedCell::LinkedCell_View *LC;
};


#endif /* LINKEDCELL_VIEWUNITTEST_HPP_ */
